/* ---------------------------------------------------------- 
%   (C)1993 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_SCHEDULE_H_
#define _KLIC_SCHEDULE_H_

extern struct prioqrec* more_prioqrec(void);

extern module topsucceed(
  struct global_variables* glbl, struct goalrec* qp,
  q* allocp, const struct predicate* toppred );

extern struct goalrec* enqueue_goal(
  struct goalrec* qp, long prio,
  struct goalrec* gp, struct global_variables* glbl );

extern struct goalrec* get_top_priority_queue(void);
extern void put_top_priority_queue(struct goalrec* qp, long prio);

#endif /* _KLIC_SCHEDULE_H_ */
